
! $Header$

SUBROUTINE laplacien_rot( klevel, rotin, rotout,ghx,ghy )
  !
  !    P. Le Van
  !
  !   ************************************************************
  !    ...  calcul de  ( rotat x nxgrad )  du rotationnel rotin  .
  !   ************************************************************
  !
  ! klevel et rotin  sont des arguments  d'entree pour le s-prog
  !  rotout           est  un argument  de sortie pour le s-prog
  !
  USE lmdz_filtreg, ONLY: filtreg
  USE lmdz_comgeom

  IMPLICIT NONE
  !
  INCLUDE "dimensions.h"
  INCLUDE "paramet.h"

  !
  !   ..........    variables  en  arguments     .............
  !
  INTEGER :: klevel
  REAL :: rotin( ip1jm,klevel ), rotout( ip1jm,klevel )
  !
  !   ..........    variables   locales       ................
  !
  REAL :: ghy(ip1jm,klevel), ghx(ip1jmp1,klevel)
  !   ........................................................
  !
  !
  CALL  filtreg ( rotin ,   jjm, klevel,   2, 1, .FALSE., 1 )

  CALL   nxgrad ( klevel, rotin,   ghx ,  ghy               )
  CALL   rotatf  ( klevel, ghx  ,   ghy , rotout             )
  !
  RETURN
END SUBROUTINE laplacien_rot
