
! $Header$

SUBROUTINE laplacien_rotgam( klevel, rotin, rotout )
  !
  ! P. Le Van
  !
  !   ************************************************************
  !   ... calcul de  (rotat x nxgrad)_gam  du rotationnel rotin ..
  !   ************************************************************
  ! klevel et teta  sont des arguments  d'entree pour le s-prog
  !  divgra     est  un argument  de sortie pour le s-prog
  !
  USE lmdz_comgeom

  IMPLICIT NONE
  !
  INCLUDE "dimensions.h"
  INCLUDE "paramet.h"

  !
  !    .............   variables  en  arguments    ...........
  !
  INTEGER :: klevel
  REAL :: rotin( ip1jm,klevel ), rotout( ip1jm,klevel )
  !
  !   ............     variables   locales     ...............
  !
  INTEGER :: l, ij
  REAL :: ghy(ip1jm,llm), ghx(ip1jmp1,llm)
  !   ........................................................
  !
  !

  CALL   nxgrad_gam ( klevel, rotin,   ghx ,   ghy  )
  CALL   rotat_nfil ( klevel, ghx  ,   ghy , rotout )
  !
  DO l = 1, klevel
    DO ij = 1, ip1jm
     rotout(ij,l) = rotout(ij,l) * unsairz_gam(ij)
    ENDDO
  ENDDO

  RETURN
END SUBROUTINE laplacien_rotgam
